<div fxLayout="column">
    <table mat-table [dataSource]="uiDatas" class="edition-table"
           multiTemplateDataRows
           aria-describedby="table to edit borrowers">

        <ng-container matColumnDef="name">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'BORROWER.EDITION.TABLE.HEADERS.NAME' | translate}} </th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <mat-form-field appearance="outline" class="editable-field mff-space-1" subscriptSizing="dynamic">
                    <input matInput formControlName="name">
                </mat-form-field>
            </td>
        </ng-container>

        <ng-container matColumnDef="avatar">
            <td mat-cell *matCellDef="let element; let index = dataIndex"></td>
        </ng-container>

        <ng-container matColumnDef="loans">
            <th mat-header-cell *matHeaderCellDef
                scope="col"> {{'BORROWER.EDITION.TABLE.HEADERS.LOANS' | translate}}</th>
            <td mat-cell *matCellDef="let element; let index = dataIndex"
                [formGroup]="uiDatas[index].form">
                <ng-container *ngIf="uiDatas[index].item as item">
                    <div fxLayoutGap="1rem">
                        <button mat-button type="button" [disabled]="item.currentLoansCount <= 0"
                                (click)="expand(expandedElement, index)">
                            <div *ngIf="item.currentLoansCount > 0; else nothingToDisplay">
                                <div *ngIf="expandedElement !== index; else open">
                                    <span> {{'BORROWER.EDITION.BUTTON.DISPLAY' | translate}} </span>
                                    <fa-icon style="margin-left: 0.5rem" [icon]="['fas', 'eye']"></fa-icon>
                                </div>
                                <ng-template #open>
                                    <span> {{'BORROWER.EDITION.BUTTON.HIDE' | translate}} </span>
                                    <fa-icon style="margin-left: 0.5rem" [icon]="['fas', 'eye-slash']"></fa-icon>
                                </ng-template>
                            </div>
                            <ng-template #nothingToDisplay>
                                <span> {{'BORROWER.EDITION.BUTTON.NOTHING_TO_DISPLAY' | translate}} </span>
                            </ng-template>
                        </button>
                    </div>
                </ng-container>
            </td>
        </ng-container>

        <ng-container matColumnDef="loansExpand">
            <td mat-cell
                *matCellDef="let element; let index = dataIndex"
                [attr.colspan]="displayedColumns.length - 1 ">
                <div class="example-element-detail"
                     [@detailExpand]="index === expandedElement ? 'expanded' : 'collapsed'">
                    <div fxLayout="column" fxFlex="100" style="padding-top: 0.5rem; padding-bottom: 0.5rem">
                        <div style="height: 40px" fxLayout="row" fxLayoutAlign="space-between"
                             *ngFor="let loan of getLoans(index); let i = index; trackBy:getId">
                            <div fxLayoutAlign="center center" fxLayoutGap="1rem">
                                <app-title-display
                                        [series]="loan.book.series" [title]="loan.book.title">
                                </app-title-display>
                                <span> {{'BORROWER.EDITION.TABLE.BORROW_DATE' | translate}}
                                    : {{ loan.borrowDate | date:"dd-MM-yyyy" }}</span>
                                <span *ngIf="loan.returnDate !== null"> {{'BORROWER.EDITION.TABLE.RETURN_DATE' | translate}}
                                    : {{ loan.returnDate | date:"dd-MM-yyyy" }}</span>
                            </div>
                            <button mat-button *ngIf="loan.returnDate === null"
                                    type="button" color="primary" (click)="returnLoan(index, i)">
                                <span> {{'BORROWER.EDITION.BUTTON.RETURN_BOOK' | translate}} </span>
                            </button>
                            <button mat-button type="button" color="warn" (click)="deleteLoan(index, i)">
                                <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                            </button>
                        </div>
                    </div>
                </div>
            </td>
        </ng-container>

        <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef scope="col"></th>
            <td mat-cell *matCellDef="let element; let index = dataIndex" [formGroup]="uiDatas[index].form">
                <div class="action-column-edition">
                    <div class="action-column-edition-buttons">
                        <button mat-button type="button" color="warn" (click)="delete(index)">
                            <fa-icon [icon]="['fas', 'trash']"></fa-icon>
                        </button>
                    </div>
                    <app-progressbar [start]="uiDatas[index].start" (finish)="onFinish(index)"></app-progressbar>
                </div>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row
            [ngClass]="{'edition-line': true, 'saved': (uiDatas[index].isSaved | async)}"
            *matRowDef="let element; columns: displayedColumns; let index = dataIndex">
        </tr>
        <tr mat-row *matRowDef="let row; columns: ['avatar','loansExpand']" class="example-detail-row"></tr>
    </table>
    <mat-paginator [pageSizeOptions]="pageSizes"
                   [pageIndex]="currentPage$ | async"
                   [length]="totalCount$ | async"
                   [pageSize]="pageSize$ | async"
                   (page)="onNewPage($event)">
    </mat-paginator>
</div>

